/**
 * DevExtreme (core/utils/scroll_rtl_behavior.js)
 * Version: 20.1.11 (build 21097-0311)
 * Build date: Wed Apr 07 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
var _dom_adapter = require("../dom_adapter");
var _dom_adapter2 = _interopRequireDefault(_dom_adapter);
var _call_once = require("./call_once");
var _call_once2 = _interopRequireDefault(_call_once);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}
var getScrollRtlBehavior = (0, _call_once2.default)(function() {
    var document = _dom_adapter2.default.getDocument();
    document.body.insertAdjacentHTML("beforeend", "<div style='direction: rtl;\n       position: absolute; left: 0; top: -1; overflow: hidden; width: 1px;\n       height: 1px;'><div style='width: 2px; height: 1px;'></div></div>");
    var scroller = document.body.lastElementChild;
    var initiallyPositive = scroller.scrollLeft > 0;
    scroller.scrollLeft = -1;
    var hasNegative = scroller.scrollLeft < 0;
    var result = {
        decreasing: hasNegative || initiallyPositive,
        positive: !hasNegative
    };
    document.body.removeChild(scroller);
    return result
});
exports.default = getScrollRtlBehavior;
